package juliac.generated;

import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.ow2.frascati.tinfi.control.property.IllegalPromoterException;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import java.util.Map;
import org.objectweb.fractal.api.control.NameController;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;
import java.util.Set;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin
 */
public class SCAPropertyControllerImpl implements Controller , Generated , SCAPropertyController {
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#properties
     */
    private Map<java.lang.String, java.lang.Object>  properties = new HashMap<java.lang.String, java.lang.Object> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#promoters
     */
    private Map<java.lang.String, org.ow2.frascati.tinfi.control.property.SCAPropertyController>  promoters = new HashMap<java.lang.String, org.ow2.frascati.tinfi.control.property.SCAPropertyController> ();
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * The {@link NameController} interface of the component to which this
     * controller object belongs.
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#weaveableOptNC
     */
    public NameController weaveableOptNC;
    
    /** 
     * Set the value for the specified property name. If the property has
     * already been set, the old value is lost, and the new value is recorded.
     * 
     * @param name   the property name
     * @param value  the property value
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#set(java.lang.String,java.lang.Object)
     */
    public void set(String name, Object value) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            properties.put(name ,value);
        } else {
            promoter.set(name ,value);
        }
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.control.name.UseNameControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptNC = ((NameController)(ic.getOptionalInterface("name-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * Return the value for the specified property name. Return null if the
     * property has not been set.
     * 
     * @param name  the property name
     * @return      the property value
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#get(java.lang.String)
     */
    public Object get(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            return properties.get(name);
        } else {
            return promoter.get(name);
        }
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$1(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Return <code>true</code> if the specified property name has been set.
     * 
     * @param name  the property name
     * @return      <code>true</code> if the property has been set,
     *              <code>false</code> otherwise
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#containsKey(java.lang.String)
     */
    public boolean containsKey(String name) {
        SCAPropertyController promoter = promoters.get(name);
        if (promoter == null) {
            return properties.containsKey(name);
        } else {
            return promoter.containsKey(name);
        }
    }
    
    /** 
     * Return a map of all the properties which have been set so far.
     * 
     * @return  a map of all the properties which have been set so far
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#getAll()
     */
    public Map<java.lang.String, java.lang.Object>  getAll() {
        Map<java.lang.String, java.lang.Object>  result = new HashMap<java.lang.String, java.lang.Object> ();
        for (Map.Entry<java.lang.String, java.lang.Object>  entry : properties.entrySet()) {
            String name = entry.getKey();
            Object value = null;
            SCAPropertyController promoter = promoters.get(name);
            if (promoter == null) {
                value = entry.getValue();
            } else {
                value = promoter.get(name);
            }
            result.put(name ,value);
        }
        return result;
    }
    
    /** 
     * Set the reference of the property controller which promotes the specified
     * property to the current property controller.
     * 
     * @param name      the promoter property name
     * @param promoter  the promoter component or
     *                  <code>null</code> to unregister the promoter
     * @throws IllegalPromoterException
     *      thrown when attempting to set a cycle between property promoters
     * @since 0.4.3
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#setPromoter(java.lang.String,org.ow2.frascati.tinfi.control.property.SCAPropertyController)
     */
    public void setPromoter(String name, SCAPropertyController promoter) throws IllegalPromoterException {
        promoters.put(name ,promoter);
        if (promoter != null) {
            SCAPropertyController peer = promoter.getPromoter(name);
            if (peer == (this)) {
                String compname = weaveableOptNC.getFcName();
                throw new IllegalPromoterException(compname);
            } 
        } 
    }
    
    /** 
     * Return the reference of the property controller which promotes the
     * specified property. Return <code>null</code> if the property is managed
     * locally by the current property controller.
     * 
     * @param name  the promoter property name
     * @return      the promoter component or <code>null</code>
     * @since 0.4.3
     * @see org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin#getPromoter(java.lang.String)
     */
    public SCAPropertyController getPromoter(String name) {
        return promoters.get(name);
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAPropertyControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.control.name.UseNameControllerMixin org.ow2.frascati.tinfi.control.property.SCAPropertyControllerMixin)";
    }
    
}

